#ifndef QPID_AMQP_0_10_EXCEPTIONS_H
#define QPID_AMQP_0_10_EXCEPTIONS_H
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/amqp_0_10/Exception.h"

namespace qpid {
namespace amqp_0_10 {


struct UnauthorizedAccessException:
    public SessionAbortedException
{
    UnauthorizedAccessException(const std::string& msg=std::string())
        : SessionAbortedException(execution::UNAUTHORIZED_ACCESS, msg) {}
  protected:
    std::string getPrefix() const { return "UnauthorizedAccessException"; }
};

struct NotFoundException:
    public SessionAbortedException
{
    NotFoundException(const std::string& msg=std::string())
        : SessionAbortedException(execution::NOT_FOUND, msg) {}
  protected:
    std::string getPrefix() const { return "NotFoundException"; }
};

struct ResourceLockedException:
    public SessionAbortedException
{
    ResourceLockedException(const std::string& msg=std::string())
        : SessionAbortedException(execution::RESOURCE_LOCKED, msg) {}
  protected:
    std::string getPrefix() const { return "ResourceLockedException"; }
};

struct PreconditionFailedException:
    public SessionAbortedException
{
    PreconditionFailedException(const std::string& msg=std::string())
        : SessionAbortedException(execution::PRECONDITION_FAILED, msg) {}
  protected:
    std::string getPrefix() const { return "PreconditionFailedException"; }
};

struct ResourceDeletedException:
    public SessionAbortedException
{
    ResourceDeletedException(const std::string& msg=std::string())
        : SessionAbortedException(execution::RESOURCE_DELETED, msg) {}
  protected:
    std::string getPrefix() const { return "ResourceDeletedException"; }
};

struct IllegalStateException:
    public SessionAbortedException
{
    IllegalStateException(const std::string& msg=std::string())
        : SessionAbortedException(execution::ILLEGAL_STATE, msg) {}
  protected:
    std::string getPrefix() const { return "IllegalStateException"; }
};

struct CommandInvalidException:
    public SessionAbortedException
{
    CommandInvalidException(const std::string& msg=std::string())
        : SessionAbortedException(execution::COMMAND_INVALID, msg) {}
  protected:
    std::string getPrefix() const { return "CommandInvalidException"; }
};

struct ResourceLimitExceededException:
    public SessionAbortedException
{
    ResourceLimitExceededException(const std::string& msg=std::string())
        : SessionAbortedException(execution::RESOURCE_LIMIT_EXCEEDED, msg) {}
  protected:
    std::string getPrefix() const { return "ResourceLimitExceededException"; }
};

struct NotAllowedException:
    public SessionAbortedException
{
    NotAllowedException(const std::string& msg=std::string())
        : SessionAbortedException(execution::NOT_ALLOWED, msg) {}
  protected:
    std::string getPrefix() const { return "NotAllowedException"; }
};

struct IllegalArgumentException:
    public SessionAbortedException
{
    IllegalArgumentException(const std::string& msg=std::string())
        : SessionAbortedException(execution::ILLEGAL_ARGUMENT, msg) {}
  protected:
    std::string getPrefix() const { return "IllegalArgumentException"; }
};

struct NotImplementedException:
    public SessionAbortedException
{
    NotImplementedException(const std::string& msg=std::string())
        : SessionAbortedException(execution::NOT_IMPLEMENTED, msg) {}
  protected:
    std::string getPrefix() const { return "NotImplementedException"; }
};

struct InternalErrorException:
    public SessionAbortedException
{
    InternalErrorException(const std::string& msg=std::string())
        : SessionAbortedException(execution::INTERNAL_ERROR, msg) {}
  protected:
    std::string getPrefix() const { return "InternalErrorException"; }
};

struct InvalidArgumentException:
    public SessionAbortedException
{
    InvalidArgumentException(const std::string& msg=std::string())
        : SessionAbortedException(execution::INVALID_ARGUMENT, msg) {}
  protected:
    std::string getPrefix() const { return "InvalidArgumentException"; }
};


struct NormalDetachedException:
    public SessionDetachedException
{
    NormalDetachedException(const std::string& msg=std::string())
        : SessionDetachedException(session::NORMAL, msg) {}
  protected:
    std::string getPrefix() const { return "NormalDetachedException"; }
};

struct SessionBusyDetachedException:
    public SessionDetachedException
{
    SessionBusyDetachedException(const std::string& msg=std::string())
        : SessionDetachedException(session::SESSION_BUSY, msg) {}
  protected:
    std::string getPrefix() const { return "SessionBusyDetachedException"; }
};

struct TransportBusyDetachedException:
    public SessionDetachedException
{
    TransportBusyDetachedException(const std::string& msg=std::string())
        : SessionDetachedException(session::TRANSPORT_BUSY, msg) {}
  protected:
    std::string getPrefix() const { return "TransportBusyDetachedException"; }
};

struct NotAttachedDetachedException:
    public SessionDetachedException
{
    NotAttachedDetachedException(const std::string& msg=std::string())
        : SessionDetachedException(session::NOT_ATTACHED, msg) {}
  protected:
    std::string getPrefix() const { return "NotAttachedDetachedException"; }
};

struct UnknownIdsDetachedException:
    public SessionDetachedException
{
    UnknownIdsDetachedException(const std::string& msg=std::string())
        : SessionDetachedException(session::UNKNOWN_IDS, msg) {}
  protected:
    std::string getPrefix() const { return "UnknownIdsDetachedException"; }
};


struct NormalExpiredException:
    public SessionExpiredException
{
    NormalExpiredException(const std::string& msg=std::string())
        : SessionExpiredException(session::NORMAL, msg) {}
  protected:
    std::string getPrefix() const { return "NormalExpiredException"; }
};

struct SessionBusyExpiredException:
    public SessionExpiredException
{
    SessionBusyExpiredException(const std::string& msg=std::string())
        : SessionExpiredException(session::SESSION_BUSY, msg) {}
  protected:
    std::string getPrefix() const { return "SessionBusyExpiredException"; }
};

struct TransportBusyExpiredException:
    public SessionExpiredException
{
    TransportBusyExpiredException(const std::string& msg=std::string())
        : SessionExpiredException(session::TRANSPORT_BUSY, msg) {}
  protected:
    std::string getPrefix() const { return "TransportBusyExpiredException"; }
};

struct NotAttachedExpiredException:
    public SessionExpiredException
{
    NotAttachedExpiredException(const std::string& msg=std::string())
        : SessionExpiredException(session::NOT_ATTACHED, msg) {}
  protected:
    std::string getPrefix() const { return "NotAttachedExpiredException"; }
};

struct UnknownIdsExpiredException:
    public SessionExpiredException
{
    UnknownIdsExpiredException(const std::string& msg=std::string())
        : SessionExpiredException(session::UNKNOWN_IDS, msg) {}
  protected:
    std::string getPrefix() const { return "UnknownIdsExpiredException"; }
};


struct NormalException:
    public ConnectionException
{
    NormalException(const std::string& msg=std::string())
        : ConnectionException(connection::NORMAL, msg) {}
  protected:
    std::string getPrefix() const { return "NormalException"; }
};

struct ConnectionForcedException:
    public ConnectionException
{
    ConnectionForcedException(const std::string& msg=std::string())
        : ConnectionException(connection::CONNECTION_FORCED, msg) {}
  protected:
    std::string getPrefix() const { return "ConnectionForcedException"; }
};

struct InvalidPathException:
    public ConnectionException
{
    InvalidPathException(const std::string& msg=std::string())
        : ConnectionException(connection::INVALID_PATH, msg) {}
  protected:
    std::string getPrefix() const { return "InvalidPathException"; }
};

struct FramingErrorException:
    public ConnectionException
{
    FramingErrorException(const std::string& msg=std::string())
        : ConnectionException(connection::FRAMING_ERROR, msg) {}
  protected:
    std::string getPrefix() const { return "FramingErrorException"; }
};

}} // namespace qpid::amqp_0_10

#endif  /*!QPID_AMQP_0_10_EXCEPTIONS_H*/
